<template>
    <div>
        <input
            type="file"
            id="sgf"
            ref="sgf"
            @change="importerSGF()"
            hidden
            multiple
        />
        <button class="uk-button uk-button-default" @click="ouvrirImport()">
            Importer
        </button>
        <table class="uk-table">
            <tr>
                <td>Fichier</td>
                <td>Niveau</td>
                <td>Type exercice</td>
                <td>Titre</td>
                <td>Ordre</td>
                <td>Supprimer</td>
            </tr>
            <RepresentationFichier
                v-if="fichiers.length === 0 && fichierFactice"
                :fichier="fichierFactice"
                :parametrage="true"
            />
            <RepresentationFichier
                v-for="fichier in fichiers"
                :key="fichier.libelle"
                :fichier="fichier"
                @supprimer="supprimerFichier"
            />
        </table>

        <Multiselect
            v-if="fichiers.length === 0 && fichierFactice"
            v-model="tagsChoisis"
            tag-placeholder="Ajouter ce tag"
            placeholder="Ajouter un tag"
            selectLabel="Appuyez sur Entrée pour ajouter"
            deselectLabel="Appuyez sur Entrée pour supprimer"
            label="name"
            track-by="code"
            :options="tagsDisponibles"
            :multiple="true"
            :taggable="true"
            @tag="ajouterTag"
            class="uk-margin-small-bottom"
        />

        <button class="uk-button uk-button-default" @click="enregistrer()">
            Enregistrer
        </button>
        <div>
            <div class="error" v-for="error in errors" :key="error">
                {{ error }}
            </div>
        </div>

        <Goban
            ref="goban"
            :id="'gobanCaptureImage'"
            :situationInitiale="problemeCaptureImage.situationInitiale"
            :position="problemeCaptureImage.position"
            style="display: none"
        />
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
import FichierImport from './FichierImport';
import RepresentationFichier from './RepresentationFichier.vue';
import { getNomAdresse } from '@/components/constantes/TypeDeProbleme';
import Axios from '@/auth/axiosAuth';
import Goban from '@/components/goban/GobanGenerationImage.vue';
import creerImageGoban from '@/views/Enseignement/editerprobleme/CreationImageGoban';
import Probleme from '@/classes/Probleme';
import instancierProbleme from '@/components/outils/InstanciationProbleme';
import Multiselect from 'vue-multiselect';
@Component({
    components: {
        RepresentationFichier,
        Goban,
        Multiselect
    }
})
export default class ImportMasse extends Vue {
    @Prop() idLecon;
    private fichierFactice = new FichierImport();
    private problemeCaptureImage: Record<string, any> = [];
    private errors: string[] = [];
    private problemesCrees: Probleme[] = [];
    private tagsDisponibles = [];
    private tagsChoisis = [];

    declare $refs: {
        sgf: HTMLFormElement;
    };

    private fichiers: FichierImport[] = [];

    public ouvrirImport() {
        document.getElementById('sgf').click();
    }

    created() {
        this.fichierFactice.libelle = 'Paramètres';
    }

    mounted() {
        Axios.get('problemes/tags/' + this.$auth.user.idClub, response => {
            this.tagsDisponibles = response.data.map(tag => ({
                code: tag,
                name: tag
            }));
        });
    }

    public importerSGF() {
        const fichiers = Array.from(this.$refs.sgf.files);
        fichiers.forEach(element => {
            this.importer(element);
        });
    }

    public importer(fichier: any) {
        const fichierImport = new FichierImport();
        fichierImport.file = fichier;
        fichierImport.libelle = fichier.name;
        fichierImport.niveau = this.fichierFactice.niveau;
        fichierImport.typeProbleme = this.fichierFactice.typeProbleme;
        this.fichiers.push(fichierImport);
    }

    public supprimerFichier(fichier: FichierImport) {
        this.fichiers = this.fichiers.filter(fich => fich != fichier);
    }

    public enregistrer() {
        this.fichiers
            .reduce(async (a, fichier) => {
                await a;
                await this.envoyer(fichier);
            }, Promise.resolve())
            .then(() => {
                if (this.errors.length === 0) {
                    this.$emit('ajouterProblemes', this.problemesCrees);
                    this.problemesCrees = [];
                }
            });
    }

    envoyer(fichier: FichierImport) {
        return new Promise(resolve => {
            const data = new FormData();
            data.append('fichier', fichier.file);
            Axios.postFile(
                'problemes/import/',
                response => {
                    this.problemeCaptureImage = response.data;
                    this.problemeCaptureImage.niveau = fichier.niveau;
                    const data2 = new FormData();
                    data2.append(
                        'probleme',
                        JSON.stringify(this.problemeCaptureImage)
                    );
                    const tailleGoban = this.problemeCaptureImage.position
                        .tailleGoban;
                    new Promise(resolve => creerImageGoban(resolve)).then(
                        image => {
                            data2.append('tailleGoban', tailleGoban);
                            data2.append('decoupage', JSON.stringify(false));
                            data2.append('espace', JSON.stringify(0));
                            data2.append('idLecon', this.idLecon);
                            const tags: string[] = this.tagsChoisis.map(
                                tag => tag.name
                            );
                            data2.append('tags', JSON.stringify(tags));
                            data2.append('titre', fichier.titre);
                            data2.append(
                                'ordreAffichage',
                                JSON.stringify(fichier.ordreAffichage)
                            );
                            data2.append('image', image as string);
                            const adresse =
                                getNomAdresse(fichier.typeProbleme) +
                                '/edition/';
                            Axios.putFile(
                                adresse,
                                response => {
                                    this.fichiers = this.fichiers.filter(
                                        fich => fich != fichier
                                    );
                                    this.problemesCrees.push(
                                        instancierProbleme(response.data)
                                    );
                                    resolve('resolved');
                                },
                                data2,
                                error => {
                                    this.errors = error.message;
                                }
                            );
                        }
                    );
                },
                data,
                error => {
                    this.errors.push(
                        fichier.libelle + ' : ' + error.response.data.message
                    );
                    resolve('error');
                }
            );
        });
    }
    public ajouterTag(newTag) {
        const tag = {
            name: newTag,
            code: newTag
        };
        this.tagsDisponibles.push(tag);
        this.tagsChoisis.push(tag);
    }
}
</script>

<style scoped>
.error {
    color: red;
}
</style>
